#include <string.h>
#include <jni.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <android/log.h>
#include "HelloJNI.h"

#define LOGV(...) __android_log_print(ANDROID_LOG_VERBOSE, "libnav", __VA_ARGS__)
#define LOGD(...) __android_log_print(ANDROID_LOG_DEBUG  , "libnav", __VA_ARGS__)
#define LOGI(...) __android_log_print(ANDROID_LOG_INFO   , "libnav", __VA_ARGS__)
#define LOGW(...) __android_log_print(ANDROID_LOG_WARN   , "libnav", __VA_ARGS__)
#define LOGE(...) __android_log_print(ANDROID_LOG_ERROR  , "libnav", __VA_ARGS__)

JNIEXPORT jstring JNICALL Java_com_sklee_jnitest_HelloJNI_getString(JNIEnv *env, jobject object){
	jstring buf_devid = NULL;

	jclass cls_context = (*env)->FindClass(env, "android/content/Context");
	jfieldID fid = (*env)->GetStaticFieldID(env, cls_context, "TELEPHONY_SERVICE", "Ljava/lang/String;");
	jstring str = (*env)->GetStaticObjectField(env, cls_context, fid);
	jmethodID mid = (*env)->GetMethodID(env, cls_context, "getSystemService", "(Ljava/lang/String;)Ljava/lang/Object;");
	jobject telephony = (*env)->CallObjectMethod(env, cls_context, mid, str); //
	
	jclass cls_tm = (*env)->FindClass(env, "android/telephony/TelephonyManager");
	mid = (*env)->GetMethodID(env, cls_tm, "getDeviceId", "()Ljava/lang/String;");
	str = (*env)->CallObjectMethod(env, cls_tm, mid);
	jsize len_jstr = (*env)->GetStringUTFLength(env, str);
	(*env)->GetStringUTFRegion(env, str, 0, len_jstr, buf_devid);

	return (*env)->NewStringUTF(env, buf_devid);
}
